using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Call_LeaveRecord
    /// </summary>
    public partial class T_Call_LeaveRecord
    {
        public T_Call_LeaveRecord()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Call_LeaveRecord");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Call_LeaveRecord model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Call_LeaveRecord(");
            strSql.Append("F_CallId,F_Phone,F_LeaveTime,F_Status,F_UserId,F_UserCode,F_UserName,F_DealTime,F_DealContent,F_Remark,F_CallAppId,F_RecFileUrl,F_StartTime,F_EndTime,F_LongTime)");
            strSql.Append(" values (");
            strSql.Append("@F_CallId,@F_Phone,@F_LeaveTime,@F_Status,@F_UserId,@F_UserCode,@F_UserName,@F_DealTime,@F_DealContent,@F_Remark,@F_CallAppId,@F_RecFileUrl,@F_StartTime,@F_EndTime,@F_LongTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CallId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.VarChar,50),
                    new SqlParameter("@F_LeaveTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Status", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_UserName", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DealTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealContent", SqlDbType.NText),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CallAppId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_RecFileUrl", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_StartTime", SqlDbType.DateTime),
                    new SqlParameter("@F_EndTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LongTime", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CallId;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_LeaveTime;
            parameters[3].Value = model.F_Status;
            parameters[4].Value = model.F_UserId;
            parameters[5].Value = model.F_UserCode;
            parameters[6].Value = model.F_UserName;
            parameters[7].Value = model.F_DealTime;
            parameters[8].Value = model.F_DealContent;
            parameters[9].Value = model.F_Remark;
            parameters[10].Value = model.F_CallAppId;
            parameters[11].Value = model.F_RecFileUrl;
            parameters[12].Value = model.F_StartTime;
            parameters[13].Value = model.F_EndTime;
            parameters[14].Value = model.F_LongTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Call_LeaveRecord model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Call_LeaveRecord set ");
            strSql.Append("F_CallId=@F_CallId,");
            strSql.Append("F_Phone=@F_Phone,");
            strSql.Append("F_LeaveTime=@F_LeaveTime,");
            strSql.Append("F_Status=@F_Status,");
            strSql.Append("F_UserId=@F_UserId,");
            strSql.Append("F_UserCode=@F_UserCode,");
            strSql.Append("F_UserName=@F_UserName,");
            strSql.Append("F_DealTime=@F_DealTime,");
            strSql.Append("F_DealContent=@F_DealContent,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CallAppId=@F_CallAppId,");
            strSql.Append("F_RecFileUrl=@F_RecFileUrl,");
            strSql.Append("F_StartTime=@F_StartTime,");
            strSql.Append("F_EndTime=@F_EndTime,");
            strSql.Append("F_LongTime=@F_LongTime");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CallId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.VarChar,50),
                    new SqlParameter("@F_LeaveTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Status", SqlDbType.Int,4),
                    new SqlParameter("@F_UserId", SqlDbType.Int,4),
                    new SqlParameter("@F_UserCode", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_UserName", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_DealTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DealContent", SqlDbType.NText),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CallAppId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_RecFileUrl", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_StartTime", SqlDbType.DateTime),
                    new SqlParameter("@F_EndTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LongTime", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CallId;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_LeaveTime;
            parameters[3].Value = model.F_Status;
            parameters[4].Value = model.F_UserId;
            parameters[5].Value = model.F_UserCode;
            parameters[6].Value = model.F_UserName;
            parameters[7].Value = model.F_DealTime;
            parameters[8].Value = model.F_DealContent;
            parameters[9].Value = model.F_Remark;
            parameters[10].Value = model.F_CallAppId;
            parameters[11].Value = model.F_RecFileUrl;
            parameters[12].Value = model.F_StartTime;
            parameters[13].Value = model.F_EndTime;
            parameters[14].Value = model.F_LongTime;
            parameters[15].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_LeaveRecord ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_LeaveRecord ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_LeaveRecord GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_CallId,F_Phone,F_LeaveTime,F_Status,F_UserId,F_UserCode,F_UserName,F_DealTime,F_DealContent,F_Remark,F_CallAppId,F_RecFileUrl,F_StartTime,F_EndTime,F_LongTime from T_Call_LeaveRecord ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Call_LeaveRecord model = new CallCenterApi.Model.T_Call_LeaveRecord();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_LeaveRecord DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Call_LeaveRecord model = new CallCenterApi.Model.T_Call_LeaveRecord();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_CallId"] != null)
                {
                    model.F_CallId = row["F_CallId"].ToString();
                }
                if (row["F_Phone"] != null)
                {
                    model.F_Phone = row["F_Phone"].ToString();
                }
                if (row["F_LeaveTime"] != null && row["F_LeaveTime"].ToString() != "")
                {
                    model.F_LeaveTime = DateTime.Parse(row["F_LeaveTime"].ToString());
                }
                if (row["F_Status"] != null && row["F_Status"].ToString() != "")
                {
                    model.F_Status = int.Parse(row["F_Status"].ToString());
                }
                if (row["F_UserId"] != null && row["F_UserId"].ToString() != "")
                {
                    model.F_UserId = int.Parse(row["F_UserId"].ToString());
                }
                if (row["F_UserCode"] != null)
                {
                    model.F_UserCode = row["F_UserCode"].ToString();
                }
                if (row["F_UserName"] != null)
                {
                    model.F_UserName = row["F_UserName"].ToString();
                }
                if (row["F_DealTime"] != null && row["F_DealTime"].ToString() != "")
                {
                    model.F_DealTime = DateTime.Parse(row["F_DealTime"].ToString());
                }
                if (row["F_DealContent"] != null)
                {
                    model.F_DealContent = row["F_DealContent"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_CallAppId"] != null)
                {
                    model.F_CallAppId = row["F_CallAppId"].ToString();
                }
                if (row["F_RecFileUrl"] != null)
                {
                    model.F_RecFileUrl = row["F_RecFileUrl"].ToString();
                }
                if (row["F_StartTime"] != null && row["F_StartTime"].ToString() != "")
                {
                    model.F_StartTime = DateTime.Parse(row["F_StartTime"].ToString());
                }
                if (row["F_EndTime"] != null && row["F_EndTime"].ToString() != "")
                {
                    model.F_EndTime = DateTime.Parse(row["F_EndTime"].ToString());
                }
                if (row["F_LongTime"] != null && row["F_LongTime"].ToString() != "")
                {
                    model.F_LongTime = int.Parse(row["F_LongTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_CallId,F_Phone,F_LeaveTime,F_Status,F_UserId,F_UserCode,F_UserName,F_DealTime,F_DealContent,F_Remark,F_CallAppId,F_RecFileUrl,F_StartTime,F_EndTime,F_LongTime ");
            strSql.Append(" FROM T_Call_LeaveRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_CallId,F_Phone,F_LeaveTime,F_Status,F_UserId,F_UserCode,F_UserName,F_DealTime,F_DealContent,F_Remark,F_CallAppId,F_RecFileUrl,F_StartTime,F_EndTime,F_LongTime ");
            strSql.Append(" FROM T_Call_LeaveRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Call_LeaveRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Call_LeaveRecord T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Call_LeaveRecord";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

